﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Runtime.Serialization;
using GT.Comun.Helpers;
using GT.Comun;

namespace GT.Comun
{

    public partial class Area : IDataErrorInfo
    {
        private String _tipoAsignado;
        
        #region Miembros de IDataErrorInfo

        public string Error
        {
            get
            {

                if (this["Descripcion"] == null &&
                    this["Tipo"] == null &&
                    this["Nombre"] == null
                    )
                    return null;
                else
                    return "Error en Area";

            }
        }

        public string this[string columnName]
        {
            get
            {
                if (columnName == "Nombre")
                {
                    if (!ValidacionesEntidad.ValidarExiste(Nombre))
                        return "Introduzca un Nombre";
                }
                if (columnName == "Tipo")
                {
                    if (!ValidacionesEntidad.ValidarExiste(Tipo))
                        return "Seleccione un Tipo de Area";
                }
                if (columnName == "Descripcion")
                {
                    if (!ValidacionesEntidad.ValidarExiste(Descripcion))
                        return "Seleccione una Descripción";
                }
                
                
                return null;
            }
        }

        #endregion

        [DataMember()]
        private TipoArea TipoPrivado
        {
            get
            {
                return TipoArea;
            }
            set
            {
                if (value != null || _TipoArea.HasLoadedOrAssignedValue)
                    TipoArea = value;
            }
        }


        
        public String TipoAsignado
        {
            get
            {
                return _tipoAsignado;
            }
            set
            {
                if (value != null)
                    _tipoAsignado = value;
            }
        }

    }
}
