﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ComponentModel;
using System.Text;
using GT.LogicaNegocio;
using GT.Comun;



namespace GT.Servicios
{
    
    public class GTServicios : IGTServicios
    {
        #region Usuarios

        public BindingList<Usuario> Usuarios_ObtenerUsuariosFiltradoPor(String nombre, String email,
            Nullable<Rol> rol)
        {
            UsuarioCN usuarioCN = new UsuarioCN();
            return usuarioCN.ObtenerUsuariosFiltradoPor(nombre, email, rol);
        }

        public Boolean Usuarios_EsExperto(string usuario)
        {
            UsuarioCN usuarioCN = new UsuarioCN();
            return usuarioCN.EsExperto(usuario);
        }
        
        public Usuario Usuarios_ValidarUsuario(string usuario, string clave)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ValidarUsuario(usuario, clave);
        }
        public int Usuarios_AgregarUsuario(Usuario usuario)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.AgregarUsuario(usuario);
        }
        public void Usuarios_AgregarUsuarioToArea(int idUsuario, int idArea)
        {
            UsuarioCN usuarioCN = new UsuarioCN();
            usuarioCN.AgregarUsuarioToArea(idUsuario, idArea);
        }
        public void Usuarios_AceptarUsuarioEnArea(int idUsuario, List<int> idsArea) 
        {
            UsuarioCN usuarioCN = new UsuarioCN();
            usuarioCN.AceptarUsuarioEnArea(idUsuario, idsArea);
        }
        public void Usuarios_EliminarUsuarioEnArea(int idUsuario, List<int> idsArea)
        {
            UsuarioCN usuarioCN = new UsuarioCN();
            usuarioCN.EliminarUsuarioEnArea(idUsuario, idsArea);
        }
        
        public Usuario Usuarios_ObtenerUsuarioPorNombre(string nombre)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuarioPorNombre(nombre);
        }
        public Usuario Usuarios_ObtenerUsuarioPorId(int idUsuario)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuarioPorId(idUsuario);
        }
        
        public Rol Usuarios_ObtenerRolUsuario(string nombre)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerRolUsuario(nombre);
        }
        public BindingList<Usuario> Usuarios_ObtenerUsuariosSolicitudPendiente()
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuariosSolicitudPendiente();
        }
        public BindingList<Usuario> Usuarios_ObtenerUsuariosPorAreaComun(String nombre)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuariosPorAreaComun(nombre);
        }
        public BindingList<Usuario> Usuarios_ObtenerUsuariosPendientesPorArea(int idArea)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuariosSolicitudPendiente(idArea);
        }
        public BindingList<Usuario> Usuarios_ObtenerUsuarios()
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            return usuarioCN.ObtenerUsuarios();
        }
        public void Usuarios_ActualizarUsuario(Usuario usuario, List<int> idsArea)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            usuarioCN.ActualizarUsuario(usuario,idsArea);
        }
        public void Usuarios_EliminarUsuario(int idUsuario)
        {
            UsuarioCN usuarioCN = new UsuarioCN();

            usuarioCN.EliminarUsuario(idUsuario);

        }

        #endregion

        #region TipoAreas

        public void TipoAreas_AgregarTipoArea(TipoArea tipoArea)
        {
            TipoAreaCN areaCN = new TipoAreaCN();
            areaCN.AgregarTipoArea(tipoArea);
        }

        public void TipoAreas_ModificarTipoArea(TipoArea tipoAreaNew, TipoArea tipoAreaOld)
        {
            TipoAreaCN areaCN = new TipoAreaCN();
            areaCN.ModificarTipoArea(tipoAreaNew, tipoAreaOld);
        }

        public void TipoAreas_EliminarTipoArea(TipoArea tipoArea)
        {
            TipoAreaCN areaCN = new TipoAreaCN();
            areaCN.EliminarTipoArea(tipoArea);
        }

        public BindingList<TipoArea> TipoAreas_ObtenerTiposArea()
        {
            TipoAreaCN areaCN = new TipoAreaCN();
            return areaCN.ObtenerTiposArea();
        
        }
        public BindingList<TipoArea> TipoAreas_ObtenerTipoAreaPorLike(string nombre)
        {
            TipoAreaCN areaCN = new TipoAreaCN();
            return areaCN.ObtenerTipoAreaPorLike(nombre);
        }

        #endregion

        #region Areas

        public Area Areas_ObtenerAreaPorId(int idArea)
        {
            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreaPorId(idArea);
        }
       
        public BindingList<Area> Areas_ObtenerAreas()
        {
            
               AreaCN areaCN = new AreaCN();
               return  areaCN.ObtenerAreas();
        }
        public BindingList<Area> Areas_ObtenerAreasUsuarioPendiente(string usuario)
        {

            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreasUsuarioPendiente(usuario);
        }
        public BindingList<Area> Areas_ObtenerAreasPorIdUsuarioPendiente(int idUsuario)
        {

            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreasUsuarioPendiente(idUsuario);
        }
        public BindingList<Area> Areas_ObtenerAreasConUsuarioPendiente()
        {

            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreasConUsuarioPendiente();
        }

        public void Areas_ObtenerInfoAreasUsuarioId(ref BindingList<Area> todas,
            ref BindingList<Area> solicitadas, ref BindingList<Area> experto, int idUsuario)
        {
            AreaCN areaCN = new AreaCN();
            areaCN.ObtenerInfoAreasUsuarioId(ref todas, ref solicitadas, ref experto, idUsuario);
        }

        public BindingList<Area> Areas_ObtenerAreasPorNombre(String nombre)
        {

            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreas(nombre);
        }

        public BindingList<Area> Areas_ObtenerAreasPorExperto(int idUsuario)
        {

            AreaCN areaCN = new AreaCN();
            return areaCN.ObtenerAreasUsuarioExperto(idUsuario);
        }

        public void Areas_EliminarArea(int idArea)
        {
            AreaCN areaCN = new AreaCN();
            areaCN.EliminarArea(idArea);
        }

        public void Areas_ModificarArea(Area area)
        {
            AreaCN areaCN = new AreaCN();
            areaCN.ModificarArea(area);
        }
        
        public int Areas_AgregarArea(Area area)
        {
            AreaCN areaCN = new AreaCN();
            return areaCN.AgregarArea(area);
        }

        #endregion

        #region Terminos


        public void Terminos_ModificarTermino(Termino termino, List<int> idArea)
        {
            TerminoCN terminoCN = new TerminoCN();
            terminoCN.modificarTermino(termino, idArea);
        }
        public int Terminos_Agregar(Termino termino,List<int> idArea) {

            TerminoCN terminoCN = new TerminoCN();
            return terminoCN.agregarTermino(termino, idArea);
        }
        public BindingList<Termino> Terminos_ObtenerTerminosPorAreaId(int idArea)
        {
            TerminoCN terminoCN = new TerminoCN();
            return terminoCN.ObtenerTerminosPorAreaId(idArea);
        }
        public BindingList<Termino> Terminos_ObtenerTerminosPorLike(String nombre)
        {
            TerminoCN terminoCN = new TerminoCN();
            return terminoCN.ObtenerTerminosPorLike(nombre);
        }
        public BindingList<Termino> Terminos_ObtenerTerminos()
        {
            TerminoCN terminoCN = new TerminoCN();
            return terminoCN.ObtenerTerminos();
        }
        public void Terminos_eliminarTermino(int idTermino, List<int> idArea)
        {
            TerminoCN terminoCN = new TerminoCN();
            terminoCN.eliminarTermino(idTermino, idArea);
        }
        public Termino Terminos_ObtenerTerminoPorId(int idTermino)
        {
            TerminoCN terminoCN = new TerminoCN();
            return terminoCN.ObtenerTerminoPorId(idTermino);
        }

        #endregion

        #region mensajes

        public int Mensajes_AgregarMensaje(string asunto, string contenido, int idRemitente, int idDestinatario)
        {
            MensajeCN mensajeCN = new MensajeCN();
            return mensajeCN.AgregarMensaje(asunto, contenido, idRemitente, idDestinatario);
        }

        public BindingList<Mensaje> Mensajes_ObtenerMensajePorDestinatario(int idDestinatario)
        {
            MensajeCN mensajeCN = new MensajeCN();
            return mensajeCN.ObtenerMensajePorDestinatario(idDestinatario);
        }

        public BindingList<Mensaje> Mensajes_ObtenerMensajePorRemitente(int idRemitente)
        {
            MensajeCN mensajeCN = new MensajeCN();
            return mensajeCN.ObtenerMensajePorRemitente(idRemitente);
        }
        public void Mensajes_EliminarMensaje(int idMensaje)
        {
            MensajeCN mensajeCN = new MensajeCN();
            mensajeCN.EliminarMensaje(idMensaje);
        }
        public void Mensajes_ActualizarMensaje(Mensaje mensaje) 
        {
            MensajeCN mensajeCN = new MensajeCN();
            mensajeCN.ActualizarMensaje(mensaje);
        }
        public Mensaje Mensajes_ObtenerMensajePorId(int idMensaje)
        {
            MensajeCN mensajeCN = new MensajeCN();
            return mensajeCN.ObtenerMensajePorId(idMensaje);
        }

        #endregion


        #region Informes

        public byte[] ObtenerInforme(String informe)
        {
            GT.Informes.Informes infor = new GT.Informes.Informes();
            return infor.ObtenerInforme(informe);
        }

        #endregion
    }
}
