﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using GT.Comun;
using System.ComponentModel;

namespace GT.Servicios
{
    [ServiceContract]
    public interface IGTServicios
    {
        #region Usuarios

        [OperationContract]
        Boolean Usuarios_EsExperto(string usuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Usuario Usuarios_ValidarUsuario(string nifUsuario, string clave);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        int Usuarios_AgregarUsuario(Usuario usuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Usuarios_AgregarUsuarioToArea(int idUsuario, int idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Usuarios_AceptarUsuarioEnArea(int idUsuario, List<int> idsArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Usuarios_EliminarUsuarioEnArea(int idUsuario, List<int> idsArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Usuario> Usuarios_ObtenerUsuariosPorAreaComun(String nombre);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Usuario Usuarios_ObtenerUsuarioPorNombre(string nombre);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Rol Usuarios_ObtenerRolUsuario(string nombre);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Usuario Usuarios_ObtenerUsuarioPorId(int idUsuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Usuario> Usuarios_ObtenerUsuariosFiltradoPor(String nombre, String email,
            Nullable<Rol> rol);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Usuarios_ActualizarUsuario(Usuario usuario, List<int> idsArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Usuarios_EliminarUsuario(int idUsuario);

        #endregion

        #region TipoAreas

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void TipoAreas_AgregarTipoArea(TipoArea tipoArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void TipoAreas_ModificarTipoArea(TipoArea tipoAreaNew, TipoArea tipoAreaOld);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void TipoAreas_EliminarTipoArea(TipoArea tipoArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<TipoArea> TipoAreas_ObtenerTiposArea();

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<TipoArea> TipoAreas_ObtenerTipoAreaPorLike(string nombre);

        #endregion

        #region Areas

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        int Areas_AgregarArea(Area Area);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Area Areas_ObtenerAreaPorId(int idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreas();

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreasPorNombre(String nombre);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Areas_EliminarArea(int idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Areas_ObtenerInfoAreasUsuarioId(ref BindingList<Area> todas,
             ref BindingList<Area> solicitadas, ref BindingList<Area> experto, int idUsuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreasPorExperto(int idUsuario);
        
        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Areas_ModificarArea(Area area);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreasConUsuarioPendiente();

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreasPorIdUsuarioPendiente(int idUsuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Area> Areas_ObtenerAreasUsuarioPendiente(String usuario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Usuario> Usuarios_ObtenerUsuariosSolicitudPendiente();

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Usuario> Usuarios_ObtenerUsuariosPendientesPorArea(int idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Usuario> Usuarios_ObtenerUsuarios();


        #endregion


        #region Terminos
        
        [OperationContract]
        [ReferencePreservingDataContractFormat]
        int Terminos_Agregar(Termino termino, List<int> idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Termino> Terminos_ObtenerTerminosPorAreaId(int idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Termino> Terminos_ObtenerTerminosPorLike(String nombre);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Termino> Terminos_ObtenerTerminos();

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Terminos_eliminarTermino(int idTermino, List<int> idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Terminos_ModificarTermino(Termino termino, List<int> idArea);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Termino Terminos_ObtenerTerminoPorId(int idTermino);

        #endregion

        #region Informes
        [OperationContract]
        byte[] ObtenerInforme(String informe);
        #endregion

        #region Mensajes

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        int Mensajes_AgregarMensaje(string asunto, string contenido, int idRemitente, int idDestinatario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Mensaje> Mensajes_ObtenerMensajePorDestinatario(int idDestinatario);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        BindingList<Mensaje> Mensajes_ObtenerMensajePorRemitente(int idRemitente);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Mensajes_EliminarMensaje(int idMensaje);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        void Mensajes_ActualizarMensaje(Mensaje mensaje);

        [OperationContract]
        [ReferencePreservingDataContractFormat]
        Mensaje Mensajes_ObtenerMensajePorId(int idMensaje);

        #endregion
    }
}
