﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using GT.Comun;
using GT.LogicaNegocio;
using System.Security.Principal;
using System.Threading;

/// <summary>
/// Summary description for Seguridad
/// </summary>
public class Seguridad
{
    private const string _passwordCacheSufix = "Password";
    private const string _usuarioAuthCacheSufix = "Usuario";

    public static bool ValidarUsuario(string userName, string password)
    {
        // Valida el usuario y la clave
        Usuario usuario;
        UsuarioCN usuariosCN = new UsuarioCN();
        string cacheKey;
        string passwordCache;
        bool correcto = true;

        if (userName.ToLower() != "invitado")
        {
            cacheKey = userName + "\\t" + _passwordCacheSufix;
            passwordCache = (string)CacheManager.GetItem(cacheKey);
            if (passwordCache == null)
            {
                usuario = usuariosCN.ValidarUsuario(userName, password);
                if (usuario != null)
                    CacheManager.AddItem(cacheKey, password);
                else
                    correcto = false;
            }
            else
            {
                if (passwordCache != password)
                    correcto = false;
            }
        }

        return correcto;
    }

    public static GenericPrincipal ObtenerPrincipal(string userName)
    {
        string cacheKey;
        Usuario usuario;
        UsuarioCN usuariosCN = new UsuarioCN();

        if (userName == null || userName.ToLower() == "invitado")
        {
            return new GenericPrincipal(new GenericIdentity("invitado"), null);
        }
        else
        {
            cacheKey = userName + "\\t" + _usuarioAuthCacheSufix;
            usuario = (Usuario)CacheManager.GetItem(cacheKey);
            if (usuario == null)
            {
                ImpersonarLlamada();

                usuario = usuariosCN.ObtenerUsuarioPorNombre(userName);

                CancelarImpersonarLlamada();

                if (usuario == null)
                    return null;
            }

            //Rol mRol = UserRolToRol(usuario.Rol);
            return CrearPrincipalDeUsuario(usuario.Nombre, usuario.Rol);
        }
    }

    //private static Rol UserRolToRol(int rolUsuario)
    //{
    //    if (rolUsuario == 0)
    //    {
    //        return Rol.Experto;
    //    }
    //    else
    //    {
    //        return Rol.Administrador;
    //    }
    //}

    private static GenericPrincipal CrearPrincipalDeUsuario(string nif, Rol rol)
    {
        GenericIdentity identity;
        GenericPrincipal principal;
      
        identity = new GenericIdentity(nif);
        if (rol == Rol.Administrador)
            principal = new GenericPrincipal(identity, new string[] { "Administrador" });
        else
            principal = new GenericPrincipal(identity, new string[] { "Experto" });

        return principal;
    }


    private static void ImpersonarLlamada()
    {
        Thread.CurrentPrincipal = new GenericPrincipal(new GenericIdentity("Administrador"), new string[] { "Administrador" });
    }

    private static void CancelarImpersonarLlamada()
    {
        Thread.CurrentPrincipal = null;
    }
}
