﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web;
using System.Xml.Linq;
using GT.Comun;
using System.ComponentModel;
using System.Collections.Specialized;
namespace GT.Web
{
    public class UsuariosMembershipProvider : MembershipProvider
    {

        private string _applicationName = "GT";

        public UsuariosMembershipProvider()
        {

        }

        #region "Métodos de MembershipProvider"

        public override string ApplicationName
        {
            get
            {
                return _applicationName;
            }
            set
            {
                _applicationName = value;
            }
        }

        public override bool ChangePassword(string username, string oldPassword, string newPassword)
        {
            throw new NotSupportedException();
        }

        public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer)
        {
            throw new NotSupportedException();
        }

        public override MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out MembershipCreateStatus status)
        {
           
            status = MembershipCreateStatus.Success;

            return new MembershipUser(base.Name, username, providerUserKey, email, passwordQuestion, null, true, false, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now); 
        }

        public override bool DeleteUser(string username, bool deleteAllRelatedData)
        {
            //Usuario usuario;
            //UsuarioCN UsuariosCN = new UsuariosCN();

            //usuario = UsuariosCN.ObtenerSocioPorNIF(username);

            //if (usuario != null)
            //    UsuariosCN.EliminarUsuario(usuario);

            //return true;
            throw new NotSupportedException();
        }

        public override bool EnablePasswordReset
        {
            get
            {
                return false;
            }
        }

        public override bool EnablePasswordRetrieval
        {
            get
            {
                return false;
            }
        }

        public override MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotSupportedException();
        }

        public override MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
        {
            throw new NotSupportedException();
        }

        public override MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords)
        {
            //BindingList<Socio> socios;
            //UsuariosCN usuariosCN = new UsuariosCN();

            //socios = usuariosCN.ObtenerSocios();
            //totalRecords = socios.Count;
            //return SociosToCollection(socios, pageIndex, pageSize);
            throw new NotSupportedException();
        }

        public override int GetNumberOfUsersOnline()
        {
            return 0;
        }

        public override string GetPassword(string username, string answer)
        {
            throw new NotSupportedException();
        }

        public override MembershipUser GetUser(object providerUserKey, bool userIsOnline)
        {
            throw new NotSupportedException();
        }

        public override MembershipUser GetUser(string username, bool userIsOnline)
        {
            throw new NotSupportedException();
        }

        public override string GetUserNameByEmail(string email)
        {
            throw new NotSupportedException();
        }


        public override void Initialize(string name, NameValueCollection config)
        {
            if (config == null)
                throw new ArgumentNullException("No hay fichero de configuracion?");

            if (String.IsNullOrEmpty(name))
                name = "UsuariosMembershipProvider";

            if (String.IsNullOrEmpty(config["description"]))
            {
                config.Remove("description");
                config.Add("description", "Proveedor de Membership de GT");
            }

            base.Initialize(name, config);
        }

        public override int MaxInvalidPasswordAttempts
        {
            get
            {
                return 0;
            }
        }

        public override int MinRequiredNonAlphanumericCharacters
        {
            get
            {
                return 0;
            }
        }

        public override int MinRequiredPasswordLength
        {
            get
            {
                return 6;
            }
        }

        public override int PasswordAttemptWindow
        {
            get
            {
                return 0;
            }
        }

        public override MembershipPasswordFormat PasswordFormat
        {
            get
            {
                return MembershipPasswordFormat.Hashed;
            }
        }

        public override string PasswordStrengthRegularExpression
        {
            get
            {
                return null;
            }
        }

        public override bool RequiresQuestionAndAnswer
        {
            get
            {
                return false;
            }
        }

        public override bool RequiresUniqueEmail
        {
            get
            {
                return true;
            }
        }

        public override string ResetPassword(string username, string answer)
        {
            throw new NotSupportedException();
        }

        public override bool UnlockUser(string userName)
        {
            throw new NotSupportedException();
        }

        public override void UpdateUser(MembershipUser user)
        {
            throw new NotSupportedException();
        }

        public override bool ValidateUser(string username, string password)
        {

            ControladorServicio proxi = new ControladorServicio(true);
            Usuario usuario;
            if (proxi.ValidarUsuario(username, password,out usuario))
            {
                //HttpContext.Current.Session["usuario"] = usuario;   
                MembershipCreateStatus estado;
                this.CreateUser(username, password, usuario.Email, null, null, true, usuario.IdUsuario, out estado);
                proxi.Dispose();
                return true;   
            }else{
                return false;
            }
            
            //usuario = usuariosCN.ValidarUsuario(username, password);
            //if (usuario == null)
            //    return false;
            ////else if (usuario.Rol == Rol.Admin)
            ////    return false;
            //else
            //    return true;
        }

        #endregion

        #region "Métodos privados"

        private MembershipUserCollection SociosToCollection(BindingList<Usuario> usuarios, int pageIndex, int pageSize)
        {
            MembershipUserCollection collection = new MembershipUserCollection();
            int i;

            for (i = (pageSize * pageIndex); i < (pageSize * (pageIndex + 1)); i++)
            {
                if (i < usuarios.Count)
                    collection.Add(SocioToMembershipUser(usuarios[i]));
                else
                    return collection;
            }

            return collection;

        }

        private MembershipUser SocioToMembershipUser(Usuario socio)
        {
            return new MembershipUser(base.Name, socio.Nombre, socio.IdUsuario, socio.Email, null, null, true, false, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now);
        }

       
        #endregion

    }
}
