﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.ComponentModel;
using GT.Comun.Helpers;
using GT.Comun;

namespace GT.Web
{
    public partial class AreaDetalle : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (!IsPostBack)
                {
                    if (PreviousPage != null && (PreviousPage.GetType().BaseType == typeof(AreaListado)))
                    {
                        AreaListado paginaPrevia = (AreaListado)PreviousPage.Page;
                        Session["areaIdSel"] = paginaPrevia.idAreaSeleccionda;
                        cargarArea(paginaPrevia.idAreaSeleccionda);
                    }
                    else
                    {
                        if (Session["idArea"]!=null)
                            {
                                int idArea = Convert.ToInt32(Session["idArea"]);
                                Session["areaIdSel"] = idArea;
                                cargarArea(idArea);
                            }
                    }
                }
                
                if (Roles.IsUserInRole("Experto") || Roles.IsUserInRole("Administrador"))
                {
                    tablaUserExpert.Visible = false;
                    //Si ya es experto deshabilito la opcion de solicitud
                    ControladorServicio controlador = new ControladorServicio(false);
                    BindingList<Area> areasExperto =
                    controlador.obteneraAreaPorUsuarioExperto(controlador.ObtenerUsuarioPorNombre(User.Identity.Name).IdUsuario);
                    if (areasExperto.Where(a => a.IdArea == Convert.ToInt32(Session["areaIdSel"])).SingleOrDefault()==null)
                        tablaUserExpert.Visible = true;
                    controlador.Dispose(); 
                }
            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                ErrorMsg.Visible = true;
                ErrorMsg.Text = "Ocurrió un error accediendo al area";
            } 
          
        }
        protected void cargarArea(int idArea)
        {
            ControladorServicio controlador = new ControladorServicio(true);
            Area area = controlador.obteneraAreaPorId(idArea);
            lblNombre.Text = area.Nombre;
            lblDescripcion.Text = area.Descripcion;
            lblTipoArea.Text = area.TipoArea.Descripcion;
            controlador.Dispose();
            ErrorMsg.Visible = false;
        }
        protected void Link_commmand(object sender, CommandEventArgs e)
        {
            String idArea = Convert.ToInt32(Session["areaIdSel"]).ToString();
            Server.Transfer("SolicitudExperto.aspx?Area=" + idArea);
        }
    }
}
