﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;

namespace GT.Web
{
    public partial class AreaListado : System.Web.UI.Page
    {
        public int idAreaSeleccionda;
        public string visibleDiv;
        protected void Page_Load(object sender, EventArgs e)
        {
            
            if (!IsPostBack)
            {

                if (PreviousPage != null && PreviousPage.GetType().BaseType == typeof(AreaConsulta))
                {
                    AreaConsulta paginaPrevia = (AreaConsulta)PreviousPage.Page;
                    this.txtArea.Text = paginaPrevia.txtBuscar;
                    Session["UltimaAreaBuscada"] = this.txtArea.Text;
                }
                else
                {
                    if ((String)Session["UltimaAreaBuscada"] != null)
                    {
                        this.txtArea.Text = (String) Session["UltimaAreaBuscada"];
                    }
                }
                buscar();
            }
        }

        
        

        protected void lnkArea_onCommand(object sender, CommandEventArgs e)
        {
            idAreaSeleccionda = Convert.ToInt32(e.CommandArgument);
            Server.Transfer("AreaDetalle.aspx");
        }

        protected void lnkTermino_onCommand(object sender, CommandEventArgs e)
        {
            idAreaSeleccionda = Convert.ToInt32(e.CommandArgument);
            Server.Transfer("TerminosListado.aspx");
        }

        protected void Aceptar_Click(object sender, EventArgs e)
        {
            Session["UltimaAreaBuscada"] = this.txtArea.Text;
            buscar();
        }
        private void buscar()
        {
            ControladorServicio controlador = new ControladorServicio(true);
            BindingList<Area> areas = controlador.ObtenerAreas(this.txtArea.Text);
            if (areas.Count == 0)
            {
                lblNohayRegistros.Visible = true;
                ListaAreas.Visible = false;
                visibleDiv = "false";
            }
            else
            {
                ListaAreas.DataSource = areas;
                ListaAreas.Visible = true;
                visibleDiv = "true";
                lblNohayRegistros.Visible = false;
                ListaAreas.DataBind();
            }
            controlador.Dispose();
        }
    }
}
