﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;
using System.ComponentModel;
using GT.Comun;

namespace GT.Web.Secure.Admin
{
    public partial class AreaAlta : System.Web.UI.Page
    {
        private int idAreaActiva = 0;
        protected void Page_Load(object sender, EventArgs e)
        {

            if (!IsPostBack)
            { 
                if (Request.QueryString["accion"]!=null)
                {
                    cargarTiposArea();
                    Area area = (Area)Session["RegistroArea"];
                    //cargo los valores seleccionados
                    txtArea.Text = area.Nombre;
                    txtDescripcion.Text = area.Descripcion;
                    listTiposArea.SelectedValue = area.Tipo;
                    idAreaActiva = area.IdArea;
                    //Apariencia de la pagina según la seleccion
                    if (Request.QueryString["accion"] == "modificar") {
                        this.MnuActivo.Text = "Modificar Area";
                        btnAceptar.Text = "Modificar";
                    }
                    if (Request.QueryString["accion"] == "eliminar") {
                        this.MnuActivo.Text = "Eliminar Area";
                        btnAceptar.Text = "Eliminar";
                        txtArea.ReadOnly = true;
                        txtDescripcion.ReadOnly = true;
                        listTiposArea.Enabled = false;
                    }
                    addRegistros.Visible = true;
                }
                else { 
            
                    cargarTiposArea();
                    this.MnuActivo.Text = "Alta de Area";
                }
                addRegistros.PostBackUrl = "~/Secure/TerminosAlta.aspx?IdArea=" + idAreaActiva;
            }
  
        }

        private void cargarTiposArea()
        {
            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<TipoArea> lista = controlador.ObtenerTiposArea();
            controlador.Dispose();
            this.listTiposArea.DataSource = lista;
            this.listTiposArea.DataTextField = "TipoConDescripcion";
            this.listTiposArea.DataValueField = "Tipo";
            this.listTiposArea.DataBind();
        }

        protected void Aceptar_Click(object sender, EventArgs e)
        {
            try
            {
                ControladorServicio controlador = new ControladorServicio(false);
                Button btn = (Button)sender;
                if (btn.Text == "Eliminar")//Eliminar
                {
                    Area areaOld = (Area)Session["RegistroArea"];
                    controlador.EliminarArea(areaOld.IdArea);
                    
                    this.CorrectoMsg.Visible = true;
                    this.addRegistros.Visible = false;
                    this.CorrectoMsg.Text = this.CorrectoMsg.Text + string.Format("\r\n <br /> {0}", ((Area)Session["RegistroArea"]).Nombre);
                }
                else
                {
                    string errorMsg;
                    Area area = new Area();
                    area.Nombre = this.txtArea.Text;
                    area.Descripcion = this.txtDescripcion.Text;
                    errorMsg = area["Nombre"];
                    if (errorMsg == null)
                        errorMsg = area["Descripcion"];
                    if (errorMsg != null)
                        mostrarError(errorMsg);
                    else
                        //Alta de registro o modificación
                    {
                        int itmSeleccionados = 0;
                        foreach (ListItem itm in this.listTiposArea.Items)
                        {
                            if (itm.Selected)
                            {
                                area.TipoAsignado = itm.Value;
                                itmSeleccionados = itmSeleccionados + 1;
                                String procesoOK = "";
                                try
                                {
                                    if (btn.Text == "Modificar")
                                    {
                                        Area areaOld = (Area)Session["RegistroArea"];
                                        area.IdArea = areaOld.IdArea;
                                        controlador.ModificarArea(area);
                                        procesoOK = "Actualización";
                                    }
                                    else
                                    {
                                        idAreaActiva = controlador.AgregarArea(area);
                                        procesoOK = "Alta";
                                        activarLinkTerminos();

                                    }
                                    
                                    this.CorrectoMsg.Visible = true;
                                    this.CorrectoMsg.Text = procesoOK + " correcta del Area: " + string.Format("<br> {0}", area.Nombre);
                                }
                                catch (Exception ex)
                                {
                                    this.ErrorMsg.Visible = true;
                                    this.ErrorMsg.Text = this.ErrorMsg.Text + string.Format("\r\n {0} ({1})", area.Nombre, ex.Message);
                                }

                            }
                        }
                        if (itmSeleccionados == 0)
                        {
                            errorMsg = area["Tipo"];
                            mostrarError(errorMsg);
                        }
                    }
                }
                controlador.Dispose();
            }
            catch (Exception ex)
            {
                Context.Trace.Write(ex.Message);
                mostrarError("Error en el proceso de alta");
            }
   
        }

        private void activarLinkTerminos()
        {
            
            this.addRegistros.Visible = true;
        }

        private void mostrarError(string mensaje)
        {
            
            this.ErrorMsg.Text = mensaje;
            this.ErrorMsg.Visible = true;
        }

       

    }
}
