﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;

namespace GT.Web.Secure.Admin
{
    public partial class AreaConsulta : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                cargarLista();
            }
        }

        protected void lnkModificar_onCommand(object sender, CommandEventArgs e)
        {
            String idSeleccionado = Convert.ToString(e.CommandArgument);
            areaSeleccionada(idSeleccionado);
            Server.Transfer("AreaAlta.aspx?accion=modificar");

        }

        protected void lnkEliminar_onCommand(object sender, CommandEventArgs e)
        {
            String idSeleccionado = Convert.ToString(e.CommandArgument);
            areaSeleccionada(idSeleccionado);
            Server.Transfer("AreaAlta.aspx?accion=eliminar");

        }

        private void areaSeleccionada(string idSeleccionado)
        {
            BindingList<Area> lista = (BindingList<Area>)Session["lista"];
            Area result;
            result = lista.Where(Area => Area.IdArea == Convert.ToInt32(idSeleccionado)).SingleOrDefault();
            Session["RegistroArea"] = result;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            cargarLista();
        }
        
        private void cargarLista()
        {
            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<Area> lista = controlador.ObtenerAreas(this.txtArea.Text);
            controlador.Dispose();
            this.ListaAreas.DataSource = lista;
            this.ListaAreas.DataBind();
            Session["lista"] = lista;
        }
    }
}
