﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.Linq;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;
using GT.Comun;

namespace GT.Web.Secure.Admin
{
    public partial class AreaTipoAreaAlta : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (Request.QueryString["accion"] != null)
                {

                    TipoArea area = (TipoArea)Session["RegistroArea"];
                    //cargo los valores seleccionados
                    txtTipoArea.Text = area.Tipo;
                    txtDescripcion.Text = area.Descripcion;
                    //Apariencia de la pagina según la seleccion
                    if (Request.QueryString["accion"] == "modificar")
                    {
                        this.MnuActivo.Text = "Modificar Tipo de Area";
                        btnAceptar.Text = "Modificar";
                    }
                    if (Request.QueryString["accion"] == "eliminar")
                    {
                        this.MnuActivo.Text = "Eliminar Tipo de Area";
                        btnAceptar.Text = "Eliminar";
                        txtTipoArea.ReadOnly = true;
                        txtDescripcion.ReadOnly = true;
                        
                    }
                    
                }
                else
                {

                    this.MnuActivo.Text = "Alta de Tipo de Area";
                }

            }
  
        }

        protected void Aceptar_Click(object sender, EventArgs e)
        {

            try
            {
                ControladorServicio controlador = new ControladorServicio(false);
                Button btn = (Button)sender;
                if (btn.Text == "Eliminar")//Eliminar
                {
                    TipoArea areaOld = (TipoArea)Session["RegistroArea"];
                    controlador.EliminarTipoArea(areaOld);

                    this.CorrectoMsg.Visible = true;
                    this.CorrectoMsg.Text = "Proceso de baja finalizado correctamente: " + string.Format("\r\n {0}", ((TipoArea)Session["RegistroArea"]).Tipo);
                }
                else
                {
                    string errorMsg;
                    TipoArea tipoArea = new TipoArea();
                    tipoArea.Tipo = this.txtTipoArea.Text;
                    tipoArea.Descripcion = this.txtDescripcion.Text;
                    errorMsg = tipoArea["Tipo"];
                    if (errorMsg == null)
                        errorMsg = tipoArea["Descripcion"];
                    if (errorMsg != null)
                        mostrarError(errorMsg);
                    else
                    //Alta de registro o modificación
                    {
                        String procesoOK = "";
                        if (btn.Text == "Modificar")
                           {
                                TipoArea areaOld = (TipoArea)Session["RegistroArea"];            
                                
                                controlador.ModificarTipoArea(tipoArea,areaOld);
                                procesoOK = "Actualización";
                            }
                             else
                            {
                                controlador.AgregarTipoArea(tipoArea);
                                procesoOK = "Alta";
                              }
                            this.ErrorMsg.Visible = false;
                            this.CorrectoMsg.Visible = true;
                            this.CorrectoMsg.Text = procesoOK + " correcta del Tipo de Area: " + string.Format("<br> {0}", tipoArea.Tipo);      
                          }
                    }
                controlador.Dispose();
                }
                
            catch (Exception ex)
            {
                Context.Trace.Write(ex.Message);
                mostrarError("Error en el proceso de alta");
            }
           
        }
       

        private void mostrarError(string mensaje)
        {
            this.ErrorMsg.Text = mensaje;
            this.ErrorMsg.Visible = true;
        }
    }
}
