﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web.Secure.Admin
{
    public partial class UsuarioAlta : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (Request.QueryString["accion"] != null )
                {
                    if (Request.QueryString["accion"]=="Pendiente"){

                        cargarPerfilUsuarioPendiente();
                        //
                        
                    }
                    if (Request.QueryString["accion"] == "Modificar")
                    {

                        cargarPerfilUsuarioModificacion();
                    }
                    if (Request.QueryString["accion"] == "Eliminar")
                    {

                        cargarPerfilUsuarioEliminar();
                    }

                }
            }
        }
        private String RolToString(Rol rol)
        {
            if (rol == Rol.Administrador)
                return "1";
            else
                return "0";
        }

        private void cargarPerfilUsuarioEliminar()
        {
            int idUsuario = Convert.ToInt32(Request.QueryString["Id"]);
            MnuActivo.Text = "Eliminar Usuario";//asigno el menu
            btnAceptar.Text = "Eliminar";//modifico el texto del boton
            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<Area> lista = controlador.obteneraAreaPorUsuarioExperto(idUsuario);
            Usuario usuario = controlador.ObtenerUsuarioPorId(idUsuario);
            controlador.Dispose();
            txtNombre.Text = usuario.Nombre; txtNombre.ReadOnly = true;
            txtEmail.Text = usuario.Email; txtEmail.ReadOnly = true;
            listRoles.SelectedValue = RolToString(usuario.Rol); listRoles.Enabled = false;
            listAreas.DataSource = lista;
            listAreas.DataValueField = "IdArea";
            listAreas.DataTextField = "Nombre";
            listAreas.DataBind();
            foreach (ListItem obj in listAreas.Items)
                obj.Selected = true;
            ViewState["IdUsuario"] = idUsuario;

        }
        
        private void cargarPerfilUsuarioPendiente(){
            int idUsuario = Convert.ToInt32(Request.QueryString["Id"]);
            MnuActivo.Text = "Revisión Solicitud";//asigno el menu
            btnAceptar.Text = "Aceptar Solicitud";//modifico el texto del boton
            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<Area> lista = controlador.ObtenerAreasIdUsuarioPendiente(idUsuario);
            Usuario usuario = controlador.ObtenerUsuarioPorId(idUsuario);
            controlador.Dispose();
            txtNombre.Text = usuario.Nombre; txtNombre.ReadOnly = true;
            txtEmail.Text = usuario.Email; txtEmail.ReadOnly = true;
            listRoles.SelectedValue = RolToString(usuario.Rol); listRoles.Enabled = false;
            listAreas.DataSource = lista;
            listAreas.DataValueField = "IdArea";
            listAreas.DataTextField = "Nombre";
            listAreas.DataBind();
            foreach (ListItem obj in listAreas.Items)
                obj.Selected = true;
            ViewState["IdUsuario"] = idUsuario;

        }

        private void cargarPerfilUsuarioModificacion()
        {
            int idUsuario = Convert.ToInt32(Request.QueryString["Id"]);
            MnuActivo.Text = "Modificar Usuario";//asigno el menu
            btnAceptar.Text = "Actualizar";//modifico el texto del boton
            BindingList<Area> todas = null;
            BindingList<Area> solicitadas = null;
            BindingList<Area> experto = null;
            ControladorServicio controlador = new ControladorServicio(false);
            controlador.ObtenerInfoAreasUsuarioId(ref todas, ref solicitadas, ref experto, idUsuario);
            Usuario usuario = controlador.ObtenerUsuarioPorId(idUsuario);
            controlador.Dispose();
            txtNombre.Text = usuario.Nombre;
            txtEmail.Text = usuario.Email;
            listRoles.SelectedValue = RolToString(usuario.Rol);
            listAreas.DataSource = todas;
            listAreas.DataValueField = "IdArea";
            listAreas.DataTextField = "Nombre";
            listAreas.DataBind();
            //Si el usuario es experto en el area la selecciono
            foreach (ListItem obj in listAreas.Items)
                if (experto.Where(area => area.IdArea == Convert.ToInt32(obj.Value)).SingleOrDefault() != null)
                    obj.Selected = true;
            //Si el usuario es experto en el area la selecciono
            foreach (ListItem obj in listAreas.Items)
                if (solicitadas.Where(area => area.IdArea == Convert.ToInt32(obj.Value)).SingleOrDefault() != null)
                    obj.Text = String.Concat(obj.Text, " - Solitud Pendiente");
            //
            ViewState["IdUsuario"] = idUsuario;

        }

        protected void Aceptar_Click(object sender, EventArgs e)
        {
            try
            {
                int idUsuario = (int)ViewState["IdUsuario"];
                ControladorServicio controlador = new ControladorServicio(false);
                BindingList<int> areasId = cargarAreasSeleccionadas();
                switch (this.btnAceptar.Text)
                {
                    case "Aceptar Solicitud":
                        controlador.AceptarUsuarioEnArea(idUsuario, areasId);
                        break;
                    case "Actualizar":
                        Usuario usuarioMod = new Usuario();
                        usuarioMod.Nombre = this.txtNombre.Text;
                        usuarioMod.Email = this.txtEmail.Text;
                        usuarioMod.Rol = evaluar(this.listRoles.SelectedValue);
                        usuarioMod.IdUsuario = idUsuario;
                        controlador.ActualizarUsuario(usuarioMod, areasId);
                        break;
                    case "Eliminar":
                        controlador.EliminarUsuario(idUsuario);
                        break;
                }


                
                controlador.Dispose();
                //notifico el resultado
                CorrectoMsg.Visible = true;
                ErrorMsg.Visible = false;
            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                //notifico el resultado
                CorrectoMsg.Visible = false;
                ErrorMsg.Visible = true;
                ErrorMsg.Text = "Ocurrió un error en el proceso";
            }
                    
        }
        private Rol evaluar(String valor)
        {
            if (valor == "0")
                return Rol.Experto;
            else
                return Rol.Administrador;
        }

        protected void Rechazar_Click(object sender, EventArgs e)
        {
            try
            {
                        
            int idUsuario = (int)ViewState["IdUsuario"];
            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<int> areasId = cargarAreasSeleccionadas();
            controlador.EliminarUsuarioEnArea(idUsuario, areasId);
            controlador.Dispose();

            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                //notifico el resultado
                CorrectoMsg.Visible = false;
                ErrorMsg.Visible = true;
                ErrorMsg.Text = "Ocurrió un error en el proceso";
            }
        }
        private BindingList<int> cargarAreasSeleccionadas()
        {
            BindingList<int> areasId = new BindingList<int>();
            foreach (ListItem obj in listAreas.Items)
            {
                if (obj.Selected)
                    areasId.Add(Convert.ToInt32(obj.Value));
            }
            return areasId;
        }

        protected void Link_commmand(object sender, CommandEventArgs e)
        {
            int idRemitente = Convert.ToInt32(ViewState["IdUsuario"]);
            Server.Transfer("../EnvioMensaje.aspx?Menu=Usuarios&Id=" + idRemitente);
        }
    }
}
