﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web.Secure.Admin
{
    public partial class UsuarioConsulta : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                try
                {
                    if (comprobarFiltroPorSesiones())
                    {
                        consultar();
                    }
                    else
                    {
                        ControladorServicio controlador = new ControladorServicio(false);
                        BindingList<Usuario> lista = controlador.ObtenerUsuarios();
                        ListaAreas.DataSource = lista;
                        ListaAreas.DataBind();
                        controlador.Dispose();
                    }
                    
                }
                catch (Exception ex)
                {
                    
                    Trace.Write(ErrorConfig.ErrorAplicacion,ex.Message,ex);
                    MsgError.Text="Ocurrió un error recuperando los usuarios";
                    MsgError.Visible=true;
                }

               
            }
        }

        private bool comprobarFiltroPorSesiones()
        {
            bool filtrarUsuarios = false;
            if ((String)Session["NombreUsuario"] != "")
            {
                txtUsuario.Text = (String)Session["NombreUsuario"]; filtrarUsuarios = true;
            }
            if ((String)Session["EmailUsuario"] != "")
            {
                txtEmail.Text = (String)Session["EmailUsuario"]; filtrarUsuarios = true;
            }
            if ((String)Session["RolUsuario"] != "")
            {
                this.listRol.SelectedValue = (String)Session["RolUsuario"]; filtrarUsuarios = true;
            }
            return filtrarUsuarios;

        }

        protected void ListaAreas_Databound(object sender, RepeaterItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {

                if (((Usuario)e.Item.DataItem).Rol == Rol.Experto)
                {
                    ((Label)e.Item.FindControl("lblRol")).Text = "Experto";
                }
                if (((Usuario)e.Item.DataItem).Rol == Rol.Administrador)
                {
                    ((Label)e.Item.FindControl("lblRol")).Text = "Administrador";
                }

            }
        }

        protected void Button1_Click(object sender, EventArgs e)
        {

            consultar();
          
        }

        private void consultar()
        {
            try
            {
                ControladorServicio controlador = new ControladorServicio(false);
                Nullable<Rol> rol = null;
                if (this.listRol.SelectedValue == "0")
                    rol = Rol.Experto;
                if (this.listRol.SelectedValue == "1")
                    rol = Rol.Administrador;
                BindingList<Usuario> lista =
                controlador.ObtenerUsuariosFiltradoPor(txtUsuario.Text, txtEmail.Text, rol);
                ListaAreas.DataSource = lista;
                ListaAreas.DataBind();
                controlador.Dispose();
                //Me guardo la ultima busqueda para la vuelta atrás del menu
                Session["NombreUsuario"] = txtUsuario.Text;
                Session["EmailUsuario"] = txtEmail.Text;
                Session["RolUsuario"] = this.listRol.SelectedValue;
            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                MsgError.Text = "Ocurrió un error recuperando los usuarios";
                MsgError.Visible = true;

            }
        }

        protected void lnkModificar_onCommand(object sender, CommandEventArgs e)
        {
            int idUsuario = Convert.ToInt32(e.CommandArgument.ToString());
            Server.Transfer("UsuarioAlta.aspx?accion=Modificar&Id=" + idUsuario);
        }

        protected void lnkEliminar_onCommand(object sender, CommandEventArgs e)
        {
            int idUsuario = Convert.ToInt32(e.CommandArgument.ToString());
            Server.Transfer("UsuarioAlta.aspx?accion=Eliminar&Id=" + idUsuario);
        }

        protected void lnkMensaje_onCommand(object sender, CommandEventArgs e)
        {
            int idUsuario = Convert.ToInt32(e.CommandArgument.ToString());
            Response.Redirect("../EnvioMensaje.aspx?Menu=Usuarios&Id=" + idUsuario);
        }
    }
}
