﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web.Secure
{
    public partial class MensajeListado : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack) {

                ControladorServicio controlador = new ControladorServicio(false);
                Usuario usuario = controlador.ObtenerUsuarioPorNombre(Context.User.Identity.Name);
                ViewState["IdUsuario"] = usuario.IdUsuario;
                CargarMensajesPorDestinatario(controlador);
                CargarMensajesPorRemitente(controlador);

                controlador.Dispose();
            }
        }

        private void CargarMensajesPorDestinatario(ControladorServicio controlador)
        {
            
            BindingList<Mensaje> mensaje = controlador.ObtenerMensajePorDestinatario((int)ViewState["IdUsuario"]);
            if (mensaje.Count == 0)
            { this.MsgNoHayRecibidos.Visible = true; ListaMensajesRecibidos.Visible = false; }
            else
            { ListaMensajesRecibidos.DataSource = mensaje; ListaMensajesRecibidos.DataBind(); } 

        }
        private void CargarMensajesPorRemitente(ControladorServicio controlador)
        {
            BindingList<Mensaje> mensaje2 = controlador.ObtenerMensajePorRemitente((int)ViewState["IdUsuario"]);
            if (mensaje2.Count == 0)
            { this.MsgNoHayEnviados.Visible = true; ListaMensajesEnviados.Visible = false; }
            else
            { ListaMensajesEnviados.DataSource = mensaje2; ListaMensajesEnviados.DataBind(); }
        }
        
        protected void lnkResponder_onCommand(object sender, CommandEventArgs e)
        {
            int idRemitente = Convert.ToInt32(e.CommandArgument.ToString());
            Server.Transfer("EnvioMensaje.aspx?Menu=Listado&Id=" + idRemitente);
        }

        protected void lnkEliminar_onCommand(object sender, CommandEventArgs e)
        {
            try 
	        {	        
		            int idMensaje = Convert.ToInt32(e.CommandArgument.ToString());
                    ControladorServicio controlador = new ControladorServicio(false);
                    controlador.EliminarMensaje(idMensaje);
                    //Vuelvo a cargar la lista actualizada
                    if (e.CommandName == "cmdEliminarEnviado")
                        CargarMensajesPorRemitente(controlador);
                    if (e.CommandName == "cmdEliminarRecibido")
                        CargarMensajesPorDestinatario(controlador);
                    controlador.Dispose();
                    MsgError.Visible = false;
                    MsgOK.Visible = true;
                    MsgOK.Text = "Mensaje Eliminado Correctamente";
	        }
	        catch (Exception ex)
	        {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                MsgError.Visible = true;
                MsgOK.Visible = false;
                MsgOK.Text = "Ocurrión un error eliminando el mensaje";
	        }
                    
            
        }

        protected void lnkModificar_onCommand(object sender, CommandEventArgs e)
        {
            int idMensaje = Convert.ToInt32(e.CommandArgument.ToString());
            Server.Transfer("EnvioMensaje.aspx?Menu=Listado&IdMsg=" + idMensaje);
        }

        protected void lnkCrearMensaje_Click(object sender, EventArgs e)
        {
            Server.Transfer("EnvioMensaje.aspx?Menu=Listado");
        }
    }
}
