﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web.Secure
{
    public partial class TerminoConsulta : System.Web.UI.Page
    {

        
        protected void Page_Load(object sender, EventArgs e)
        {
            MsgError.Visible = true;
            if (!IsPostBack)
            {

                cargarLista();
            }
        }

        protected void lnkModificar_onCommand(object sender, CommandEventArgs e)
        {
            int idSeleccionado = Convert.ToInt32(e.CommandArgument);
            Server.Transfer("TerminosAlta.aspx?accion=modificar&Id=" + idSeleccionado);
        }

        protected void lnkEliminar_onCommand(object sender, CommandEventArgs e)
        {
            int idSeleccionado = Convert.ToInt32(e.CommandArgument);
            Server.Transfer("TerminosAlta.aspx?accion=eliminar&Id=" + idSeleccionado);
        }

        protected BindingList<Termino> cargarLista()
        {
            ControladorServicio controlador = new ControladorServicio(true);
            BindingList<Termino> terminos;
            if (this.txtTermino.Text == "")
            {
                terminos = controlador.ObtenerTerminos();
            }
            else
            {
                terminos = controlador.ObtenerTerminosPorLike(this.txtTermino.Text);

            }
            foreach (Termino term in terminos)
            {
                foreach (TerminoArea tera in term.TerminoArea)
                {
                    Area area = controlador.obteneraAreaPorId(tera.IdArea);
                    term.AreasConcatenadas = term.AreasConcatenadas + " - " + area.Nombre;
                }
            }
            //Guardo la ultima busqueda y el menu activo en la pagina
            controlador.Dispose();


            ListaAreas.DataSource = terminos;
            ListaAreas.Visible = true;
            ListaAreas.DataBind();

            return terminos;
        }
        
        
        protected void Button1_Click(object sender, EventArgs e)
        {
            try
            {
                cargarLista();

            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                MsgError.Visible = true;
            }

        }

        protected void Ordenar(object sender, ImageClickEventArgs e)
        {
            BindingList<Termino> terminos = cargarLista();
            List<Termino> listaOrdenada = terminos.ToList();
            switch (((ImageButton)sender).ID)
            {
                case "UpNombre":
                    listaOrdenada.Sort(new TerminoNombreSorterUp());
                    break;
                case "DownNombre":
                    listaOrdenada.Sort(new TerminoNombreSorterDown());
                    break;
                case "UpAreas":
                    listaOrdenada.Sort(new TerminoAreasSorterUp());
                    break;
                case "DownAreas":
                    listaOrdenada.Sort(new TerminoAreasSorterDown());
                    break;
                case "UpDescripcion":
                    listaOrdenada.Sort(new TerminoDescripcionSorterUp());
                    break;
                case "DownDescripcion":
                    listaOrdenada.Sort(new TerminoDescripcionSorterDown());
                    break;
                case "UpConsultado":
                    listaOrdenada.Sort(new TerminoConsultadoSorterUp());
                    break;
                case "DownConsultado":
                    listaOrdenada.Sort(new TerminoConsultadoSorterDown());
                    break;
            }
            ListaAreas.DataSource = listaOrdenada;
            ListaAreas.Visible = true;
            ListaAreas.DataBind();
        }
    }
}
