﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web.Secure
{
    public partial class Terminos : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (Roles.IsUserInRole("Experto"))
                {
                    bool hayDatos = false;
                    String usuario = Context.User.Identity.Name.ToString();
                    ControladorServicio controlador = new ControladorServicio(false);

                    Boolean res = controlador.EsExpertoAreas(usuario);

                    if (res)
                    {
                        OpcionesExperto.Visible = true; hayDatos = true;
                    }
                    else
                    {
                        OpcionesExperto.Visible = false;
                    }

                    BindingList<Area> areas = controlador.ObtenerAreasUsuarioPendiente(usuario);

                    if (areas.Count > 0)
                    {
                        LeyendaPendiente.Visible = true; hayDatos = true;
                        listaPendientes.DataSource = areas;
                        listaPendientes.DataBind();
                    }

                    if (!hayDatos)
                        this.MsgSinDatos.Visible = true;
                    else
                        this.MsgSinDatos.Visible = false;

                    controlador.Dispose();
                }

            }
            catch (Exception ex)
            {
                
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                this.ErrorMsg.Visible = true;
                this.ErrorMsg.Text = "Ocurrió un error cancelando la solicitud";
                this.CorrectoMsg.Visible = false;
            }
            
            
        }

        protected void lnkCancelar_Click(object sender, CommandEventArgs e)
        {
            try
            {
                ControladorServicio controlador = new ControladorServicio(false);
                Usuario usuario = controlador.ObtenerUsuarioPorNombre(User.Identity.Name);
                controlador.EliminarUsuarioEnArea(usuario.IdUsuario, new BindingList<int>() { Convert.ToInt32(e.CommandArgument) });
            }
            catch (Exception ex)
            {

                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                this.ErrorMsg.Visible = true;
                this.CorrectoMsg.Visible = false;
            }
        }
    }
}
