﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;
using System.ComponentModel;
using GT.Comun;
using System.Collections.Generic;

namespace GT.Web.Secure
{
    public partial class TerminosAlta : System.Web.UI.Page
    {
        int IdTerminoNew;
        
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

                if (Request.QueryString["accion"] != null)
                {
                    ControladorServicio controlador = new ControladorServicio(true);
                    Termino termino = controlador.ObtenerTerminoPorId(Convert.ToInt32(Request.QueryString["Id"]));
                    controlador.Dispose();
                    
                    if (User.IsInRole("Administrador"))
                        cargarAreas();
                    else
                        cargarAreasDeExperto();
                    
                    //cargo los valores seleccionados
                    txtTermino.Text = termino.Nombre;
                    txtDescripcion.Text = termino.Descripcion;
                    
                    //flag que comprueba si el usuario tiene derechos sobre el termino
                    bool esExpertoTermino = false;
                    foreach (TerminoArea tera in termino.TerminoArea)
                    {
                        ListItem itm = this.listArea.Items.FindByValue(tera.IdArea.ToString());
                        if (itm != null)
                        {
                            itm.Selected=true;//selecciono las areas a las que pertene el termino
                            esExpertoTermino = true;
                        }
                    }
                    if (!esExpertoTermino)
                    {
                        btnAceptar.Text = "Término fuera de su area";
                        btnAceptar.Enabled = false;
                    }
                    else { 
                        btnAceptar.Enabled = true;
                       
                        ViewState["IdTerminoOld"] = termino.IdTermino;

                        //Apariencia de la pagina según la seleccion
                        if (Request.QueryString["accion"] == "modificar")
                        {
                            this.MnuActivo.Text = "Modificar Termino";
                            btnAceptar.Text = "Modificar";
                        }
                        if (Request.QueryString["accion"] == "eliminar")
                        {
                            this.MnuActivo.Text = "Eliminar Termino";
                            btnAceptar.Text = "Eliminar";
                            txtTermino.ReadOnly = true;
                            txtDescripcion.ReadOnly = true;
                            
                        } 
                    }
                    
                }
                else
                {
                    if (Request.QueryString["IdArea"] == "0" || Request.QueryString["IdArea"] == null)
                    {
                        if (User.IsInRole("Administrador"))
                            cargarAreas();
                        else
                            cargarAreasDeExperto();
                    }
                    else
                    {
                        ControladorServicio controlador = new ControladorServicio(false);
                        Area area = controlador.obteneraAreaPorId(Convert.ToInt32(Request.QueryString["IdArea"]));
                        controlador.Dispose();
                        this.listArea.Items.Add(new ListItem(area.Nombre, area.IdArea.ToString()));
                    }
                    this.MnuActivo.Text = "Alta de Término";
                }

            }

        }

        private void cargarAreas()
        {

            ControladorServicio controlador = new ControladorServicio(false);
            BindingList<Area> lista = controlador.ObtenerAreas();
            controlador.Dispose();
            this.listArea.DataSource = lista;
            this.listArea.DataTextField = "Nombre";
            this.listArea.DataValueField = "IdArea";
            this.listArea.DataBind();
        
        
        }

        private void cargarAreasDeExperto()
        {
            ControladorServicio controlador = new ControladorServicio(false);
            Usuario usuario = controlador.ObtenerUsuarioPorNombre(User.Identity.Name);
            BindingList<Area> lista = controlador.obteneraAreaPorUsuarioExperto(usuario.IdUsuario);
            controlador.Dispose();
            this.listArea.DataSource = lista;
            this.listArea.DataTextField = "Nombre";
            this.listArea.DataValueField = "IdArea";
            this.listArea.DataBind();

        }
        
        protected void Aceptar_Click(object sender, EventArgs e)
        {
            try
            {
                ControladorServicio controlador = new ControladorServicio(false);
                Button btn = (Button)sender;

                if (btn.Text == "Eliminar")//Eliminar
                {
                    BindingList<int> areas = new BindingList<int>();
                    foreach (ListItem itm in this.listArea.Items)
                    {
                        if (itm.Selected) { areas.Add(Convert.ToInt32(itm.Value)); }
                    }
                    
                    controlador.EliminarTerminoPorId(Convert.ToInt32(ViewState["IdTerminoOld"]),areas);
                    this.CorrectoMsg.Visible = true;
                    this.CorrectoMsg.Text = this.CorrectoMsg.Text + string.Format("\r\n {0}", this.txtTermino.Text);

                }

                else
                {
                    Termino terminoNew = new Termino();
                    terminoNew.Nombre = this.txtTermino.Text;
                    terminoNew.Descripcion = this.txtDescripcion.Text;
                    BindingList<int> idsAreas = new BindingList<int>();
                    foreach (ListItem itm in this.listArea.Items)
                    {
                        if (itm.Selected)
                        {
                            idsAreas.Add(Convert.ToInt32(itm.Value));
                        }
                    }
                    if (btn.Text == "Modificar")
                    {
                        terminoNew.IdTermino = Convert.ToInt32(ViewState["IdTerminoOld"]);
                        controlador.modificarTermino(terminoNew, idsAreas);
                    }
                    else {
                        IdTerminoNew = controlador.agregarTermino(terminoNew, idsAreas);
                    
                    }
                    CorrectoMsg.Visible = true;

                    
                }

                controlador.Dispose();
            }
            catch (Exception ex)
            {
                ErrorMsg.Visible = true;
                ErrorMsg.Text = ex.Message;
            }            
        }
    }
}
