﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web
{
    public partial class SolicitudExperto : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try{
                this.MsgError.Visible = false;//oculto el estado de las alertas
                if (!IsPostBack)
                            {

                                if (Request.QueryString["Area"] == null)
                                    throw new Exception("Se requiere un Area seleccionada");

                                //obtengo los datos del area
                                int idArea = Convert.ToInt32(Request.QueryString["Area"]);
                                //guardamos el IdArea 
                                Session["idArea"] = idArea;
                                ControladorServicio proxi = new ControladorServicio(true);
                                Area area = proxi.obteneraAreaPorId(idArea);
                                proxi.Dispose();
                                this.lblArea.Text = area.Nombre;
                                this.lblAreaDes.Text = area.Descripcion;

                                if (Roles.IsUserInRole("Experto"))
                                {
                                    ControladorServicio controlador = new ControladorServicio(false);
                                    Usuario usuario = controlador.ObtenerUsuarioPorNombre(User.Identity.Name);
                                    txtNombre.Text = usuario.Nombre;
                                    txtEmail.Text = usuario.Email;
                                    txtClave.Text = "***";
                                    txtClave.Enabled = false;
                                    txtNombre.Enabled = false;
                                    txtEmail.Enabled = false;
                                    ViewState["UsuarioId"] = usuario.IdUsuario;
                                    
                                    }

                            }


            } catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message);
                this.MsgError.Visible = true;
                this.MsgError.Text = "Ocurrió un error en la solicitud. No obstante, trate de hacer login en el sistema.";
            }            
            
        }

        protected void Enviar(object sender, EventArgs e)
        {
            try
            {
                string mensaje=null;
                ControladorServicio proxi;
                int resultado=0;
                if (ViewState["UsuarioId"] != null)
                {
                    resultado = Convert.ToInt32(ViewState["UsuarioId"]);
                    proxi = new ControladorServicio(false);
                }
                else
                {
                    Usuario usuario = new Usuario();
                    usuario.Nombre = this.txtNombre.Text;
                    usuario.Email = this.txtEmail.Text;
                    usuario.Clave = this.txtClave.Text;
                    proxi = new ControladorServicio(true);
                    resultado = proxi.AgregarUsuario(usuario, out mensaje);
                }
                 
                if (resultado == 0)
                    {
                        this.MsgOK.Visible = false;
                        this.MsgError.Visible = true;
                        this.MsgError.Text = mensaje;
                    }
                    else
                    {
                        int idArea = Convert.ToInt32(Session["idArea"]);
                        proxi.AgregarUsuarioToArea(resultado, idArea);
                        
                        //mostramos el resultado del proceso
                        this.MsgOK.Visible = true;
                        this.MsgError.Visible = false;
                 }
                proxi.Dispose();
              
            }
            catch (Exception ex)
            {
                Trace.Write(ErrorConfig.ErrorAplicacion, ex.Message, ex);
                this.MsgError.Visible = true;
                this.MsgError.Text = ex.Message;
            }
            
            
            
        }
    }
}
