﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using GT.Comun;
using GT.Comun.Helpers;

namespace GT.Web
{
    public partial class TerminoDetalle : System.Web.UI.Page
    {
        public bool muestroLinkAreas = false;
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (!IsPostBack)
                {
                    BindingList<Termino> terminos = new BindingList<Termino>();
                    int terminosCount = 0;
                    BindingList<Area> areas = new BindingList<Area>();
                    int areasCount = 0;
                    int idTermino ;
                    if (Session["idTermino"] != null)
                    {
                        idTermino = Convert.ToInt32(Session["idTermino"]);
                    }
                    else
                    {
                        TerminosListado paginaPrevia = (TerminosListado)PreviousPage.Page;
                        idTermino = paginaPrevia.idTermino;
                    }
                    ControladorServicio controlador = new ControladorServicio(true);
                    Termino termino = controlador.ObtenerTerminoPorId(idTermino);
                    foreach (TerminoArea tera in termino.TerminoArea)
                    {
                        Area area = controlador.obteneraAreaPorId(tera.IdArea);
                        if (areasCount < 10)
                        {
                            areasCount = areasCount + 1; areas.Add(area);
                        }
                        if (terminosCount < 10)
                        {
                            terminos = controlador.ObtenerTerminosPorAreaId(area.IdArea);
                            terminosCount = terminosCount + terminos.Count;
                        }
                        else
                        {
                            var listaterminos = terminos.Take(10);
                            terminos.Clear();
                            foreach (Termino term in listaterminos)
                                terminos.Add(term);

                        }
                        termino.AreasConcatenadas = termino.AreasConcatenadas + " - " + area.Nombre;
                    }
                    lblNombre.Text = termino.Nombre;
                    lblDescripcion.Text = termino.Descripcion;
                    lblAreas.Text = termino.AreasConcatenadas;
                    lblVeces.Text=termino.Consultado.ToString();

                    this.AreasRelacionadas.DataSource = areas; AreasRelacionadas.DataBind();
                    this.TerminosRelacionados.DataSource = terminos; TerminosRelacionados.DataBind();
                    
                    controlador.Dispose();
                    ErrorMsg.Visible=false;
                }
                if (Session["idArea"] != null)
                    muestroLinkAreas = true;
            }
            catch (Exception ex)
            {
               Trace.Write(ErrorConfig.ErrorAplicacion,ex.Message,ex);
               ErrorMsg.Visible=true;
               ErrorMsg.Text="Ocurrió un error accediendo al termino"; 
            } 
            
        }

        protected void lnkAreas_Command(object sender, CommandEventArgs e)
        {
            int idAreaSeleccionda = Convert.ToInt32(e.CommandArgument);
            Session["idArea"] = idAreaSeleccionda;
            Server.Transfer("AreaDetalle.aspx");

        }

        protected void lnkTerminos_Command(object sender, CommandEventArgs e)
        {
            int idTermino = Convert.ToInt32(e.CommandArgument);
            Session["idTermino"] = idTermino;
            Server.Transfer("TerminoDetalle.aspx");
        }
    }
}
